; DOS

;COOR_M  LD DE,(ARW_X)      ;   /DA
;        LD A,D
;        AND #FC
;        LD D,A
;        SRL A
;        SRL A
;        LD H,A
;        LD A,E
;        SRL A
;        SRL A
;        LD L,A
;        LD BC,(BXY)

COOR_M  ld hl,(IntMagnify.hldpixel)
        ld bc,(IntMagnify.bxy)
        ADD HL,BC
mka     DUP 3
        SRL H
        SRL L
        EDUP
        RET

COOR_N  LD HL,(ARW_X)
        JR mka

COOR_P  CALL COOR_N
        PUSH HL
        LD A,H
        LD DE,CX
        CALL PDEC
        POP HL
        LD A,L
        LD DE,CY
        CALL PDEC
        JR OFC

COOR_G
OFC     LD HL,#50FC
        LD DE,CX
        DUP 3
        LD A,(DE)
        CALL PRR
        LD A,H
        SUB #07
        LD H,A
        INC L
        INC DE
        LD A,(DE)

        PUSH HL
        LD H,0
        LD L,A
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        LD BC,F64-376
        ADD HL,BC
        LD B,H
        LD C,L
        POP HL

        DUP 7
        LD A,(BC)
        AND #F0
        XOR (HL)
        LD (HL),A
        INC H
        INC BC
        EDUP
        LD A,(BC)
        AND #F0
        XOR (HL)
        LD (HL),A
        LD A,H
        SUB #07
        LD H,A
        INC DE
        EDUP
        LD A,(DE)
PRR     PUSH HL
        LD H,0
        LD L,A
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        LD BC,F64-376
        ADD HL,BC
        LD B,H
        LD C,L
        POP HL
        DUP 7
        LD A,(BC)
        AND #0F
        XOR (HL)
        LD (HL),A
        INC H
        INC BC
        EDUP
        LD A,(BC)
        AND #0F
        XOR (HL)
        LD (HL),A
        RET

F64     DEFB #00,#00,"U",#22
        DEFB #22,"U",#00,#00
        DEFB #00,#22,"UUUU",#22
        DEFB #00,#00,#22,"f"
        DEFB #22,#22,#22,"w"
        DEFB #00,#00,#22,"U"
        DEFB #11,#22,"Dw",#00
        DEFB #00,"f",#11,#22
        DEFB #11,"U",#22,#00
        DEFB #00,"UUUw",#11
        DEFB #11,#00,#00,"wDf"
        DEFB #11,#11,"f",#00
        DEFB #00,"3DfUU",#22
        DEFB #00,#00,"w",#11
        DEFB #11,#22,#22,#22
        DEFB #00,#00,#22,"U"
        DEFB #22,"UU",#22,#00
        DEFB #00,#22,"UU3",#11
        DEFB "f",#00,#00

CX      DB "000/"
CY      DB "000"

PDEC    LD (WN+1),DE
        LD L,A
        LD H,#00
        PUSH HL
        LD HL,DBW+4
        LD B,#03
LW1     XOR A
        LD E,(HL)
        INC HL
        LD D,(HL)
        INC HL
        EX (SP),HL
LW2     INC A
        SBC HL,DE
        JR NC,LW2
        ADD HL,DE
        ADD A,"0"-1
        PUSH HL
WN      LD HL,0
        LD (HL),A
        INC HL
        LD (WN+1),HL
        POP HL
        EX (SP),HL
        DJNZ LW1
        POP HL
        RET
;----------------------------------------;
DBW     DW 10000,1000,100,10,1

Main_IntP
        XOR A
        LD (23560),A
        CALL Ret
IntP1   EQU $-2
        JP Ret
IntP2   EQU $-2
;----------------------------
oncooC  LD A,#CB
        LD (mka),A
        XOR A
        LD (cof),A
        LD A,0
cofC    EQU $-1
        AND A
        JR Z,oak
        XOR A
        LD HL,Ret
        LD D,H
        LD E,L
oak_    LD (cofC),A
        JR onco__
oak     LD HL,COOR_P
        LD DE,COOR_G
        LD A,1
        JR oak_

oncoo   LD A,#C9
        LD (mka),A
        XOR A
        LD (cofC),A
        LD A,0
cof     EQU $-1
        AND A
        JR Z,onco
        XOR A
        LD HL,Ret
        LD D,H
        LD E,L
        JR onco_

onco    INC A
        LD HL,COOR_P
        LD DE,COOR_G
onco_   LD (cof),A
onco__  LD (IntP2),HL
        LD (IntG2),DE
        RET

Main_IntG
        CALL Ret
IntG1   EQU $-2
        CALL Ret
IntG2   EQU $-2
        LD A,(23560)
        CP "!"
        JR Z,oncoo
        CP "@"
        JR Z,oncooC
        RET



