; en - ENGLISH localisation /  
;------------------------------------------------;
;     Document used WINDOWS cp1251 codepage      ;
;         and compiled for SjASMPlus             ;
;------------------------------------------------;
;     WINDOWS cp1251  ;
;           SjASMPlus             ;
;------------------------------------------------;

      INCLUDE "local\en\help.asm" 

      page    GUIPage
      ORG #C000

FONT    ; Loaded at addres #C000 in GUI page
        INCBIN "52f.bin"

;              PUBLIC
;----------------------------------------------
  MACRO MSG_DISK_drive : DB "Drive" : ENDM
  MACRO MSG_DISK_Load_ : DB "Load_" : ENDM
  MACRO MSG_DISK_Save_ : DB "Save_" : ENDM
  MACRO MSG_DISK_Load  : DB "Load" : ENDM
  MACRO MSG_DISK_Save  : DB "Save" : ENDM
  MACRO MSG_OPER_or    : DB "OR"  : ENDM
  MACRO MSG_OPER_xor   : DB "XOR" : ENDM
  MACRO MSG_OPER_and   : DB "AND" : ENDM
  MACRO MSG_OPER_nop   : DB "NOP" : ENDM
  MACRO MSG_OPER_msk   : DB "MSK" : ENDM
  MACRO MSG_OPER_put   : DB "PUT" : ENDM

;             BGE_Help
;----------------------------------------------
  MACRO MSG_Help_Intr   : DB "Introduction" : ENDM
  MACRO MSG_Help_MainM  : DB "Main menu" : ENDM
  MACRO MSG_Help_FileM  : DB "File menu" : ENDM
  MACRO MSG_Help_Plugs  : DB "Plugins & overlays" : ENDM
  MACRO MSG_Help_TxtOut : DB "Text" : ENDM
  MACRO MSG_Help_Win8   : DB "Windows x8" : ENDM
  MACRO MSG_Help_Win1   : DB "Windows x1" : ENDM
  MACRO MSG_Help_RGB    : DB "Select colour" : ENDM
  MACRO MSG_Help_Loupe  : DB "Loupe" : ENDM
  MACRO MSG_Help_Diz    : DB "Dithering" : ENDM
  MACRO MSG_Help_Mix    : DB "Mixing" : ENDM
  MACRO MSG_Help_2scr   : DB "Screen 2" : ENDM
  MACRO MSG_Help_Fill   : DB "Fill" : ENDM
  MACRO MSG_Help_Prims  : DB "Primitives" : ENDM
  MACRO MSG_Help_Brush  : DB "Brushes" : ENDM
  MACRO MSG_Help_Cells  : DB "Cells" : ENDM
  MACRO MSG_Help_Misc   : DB "Miscelaneous" : ENDM
  MACRO MSG_Help_Sets   : DB "SetUp" : ENDM
  MACRO MSG_Help_Undo   : DB "Undo" : ENDM
  MACRO MSG_Help_Addi   : DB "Additionally" : ENDM
  MACRO MSG_Help_Hist   : DB "History" : ENDM
  MACRO MSG_Help_Auth   : DB "Authors" : ENDM
   
; File menu +
  MACRO MSG_DISK_File      : DB "File" : ENDM
  MACRO MSG_DISK_BLC_      : DB "Load BLC_" : ENDM
  MACRO MSG_DISK_SV_as_    : DB "Save as_" : ENDM
  MACRO MSG_DISK_SV_in_    : DB "Save in_" : ENDM
  MACRO MSG_DISK_LD_D_     : DB "Load double_" : ENDM
  MACRO MSG_DISK_SV_D_     : DB "Save double_" : ENDM
  MACRO MSG_DISK_RAMdisk_  : DB "RAM-disk_" : ENDM
  MACRO MSG_DISK_LD_p_     : DB "Load+_" : ENDM
  MACRO MSG_DISK_SV_p_     : DB "Save+_" : ENDM
  MACRO MSG_DISK_SprtSCAN  : DB "Sprite scan" : ENDM
  MACRO MSG_DISK_Files     : DB "Files" : ENDM
  
; SETUP
  MACRO MSG_SETUP_Head   : DB "SetUp" : ENDM
  MACRO MSG_SETUP_Mouse  : DB "Mouse" : ENDM  
  MACRO MSG_SETUP_SMB    : DB "BSwap" : ENDM  
  MACRO MSG_SETUP_Joi    : DB "Joystick" : ENDM  
  MACRO MSG_SETUP_Turbo  : DB "Turbo drive" : ENDM  
  MACRO MSG_SETUP_ExtMem : DB "Ext. memory" : ENDM  
  MACRO MSG_SETUP_Cursor : DB "Cursor_" : ENDM  
  MACRO MSG_SETUP_Step   : DB "Step " : ENDM    ; 5 bytes
  MACRO MSG_SETUP_Level  : DB "Level" : ENDM    ; 5 bytes  
  MACRO MSG_SETUP_Speed  : DB "Speed" : ENDM    ; 5 bytes
  MACRO MSG_SETUP_Slow_M : DB "Slow mouse" : ENDM
  MACRO MSG_SETUP_Loup8  : DB "Loupe x8" : ENDM
  MACRO MSG_SETUP_Loup   : DB "Loupe_" : ENDM
  MACRO MSG_SETUP_LpGRD4 : DB "Old Grid 4" : ENDM
  
;FILES MINI COMMANDER
  MACRO MSG_FILES_View   : DB "View" : ENDM
  MACRO MSG_FILES_Load   : DB "Load" : ENDM
  MACRO MSG_FILES_Copy   : DB "Copy" : ENDM
  MACRO MSG_FILES_Copy1  : DB "Copy_" : ENDM
  MACRO MSG_FILES_Rename : DB "Rename" : ENDM
  MACRO MSG_FILES_Delete : DB "Delete" : ENDM

; Fill
  MACRO MSG_Fill_fill  : DB "Fill" : ENDM
  MACRO MSG_Fill_solid : DB "Solid" : ENDM
  MACRO MSG_Fill_textu : DB "Textured_" : ENDM
  MACRO MSG_Fill_edit  : DB "Editor_" : ENDM
  MACRO MSG_Fill_wash  : DB "Wash" : ENDM
  MACRO MSG_Fill_washP : DB "Wash+" : ENDM

; LOUPE
  MACRO MSG_LOUPE_curs    : DB "Cursor" : ENDM
  MACRO MSG_LOUPE_default : DB "Default" : ENDM
  MACRO MSG_LOUPE_cros    : DB "Crosshair" : ENDM
  MACRO MSG_LOUPE_mbut2   : DB "Button 2" : ENDM
  MACRO MSG_LOUPE_UtoPix  : DB "Undo -> pixel" : ENDM
  MACRO MSG_LOUPE_DelPix  : DB "Delete pixel" : ENDM  
  MACRO MSG_LOUPE_UswPix  : DB "Undo <-> pixel" : ENDM
  MACRO MSG_LOUPE_Smooth  : DB "Smooth" : ENDM
  MACRO MSG_LOUPE_FMove   : DB "Scroll" : ENDM

;  MACRO MSG_LOUPE_   : DB           : ENDM 
; PIXELS MASK
  MACRO MSG_PMASK_Head    : DB "Pixels Mask" : ENDM
  MACRO MSG_PMASK_Sieve   : DB "Sieve" : ENDM
  MACRO MSG_PMASK_EdHead  : DB "Edit Mask" : ENDM
  MACRO MSG_PMASK_Clean   : DB "Clean" : ENDM  
  MACRO MSG_PMASK_Invert  : DB "Invert" : ENDM
  MACRO MSG_PMASK_Take    : DB "Take scr." : ENDM
  MACRO MSG_PMASK_Put     : DB "Put scr." : ENDM
  MACRO MSG_PMASK_Slot1   : DB "Set 1" : ENDM
  MACRO MSG_PMASK_Slot2   : DB "Set 2" : ENDM
  MACRO MSG_PMASK_Slot3   : DB "Set 3" : ENDM
  MACRO MSG_PMASK_Please  : DB "First save the settings !" : ENDM  
  
;              GUI Messages
;------------------------------------------------

 ; DOS messages

  MACRO MSG_DOS_rep : DB "   Repeat ? " : ENDM
  MACRO MSG_DOS_yes_no : DB "  Yes     No" : ENDM

  MACRO MSG_DOS_mess0 : DB "  No errors" : ENDM
  MACRO MSG_DOS_mess1 : DB "  No File" : ENDM
  MACRO MSG_DOS_mess2 : DB " File exists" : ENDM
  MACRO MSG_DOS_mess3 : DB "  Disk full" : ENDM
  MACRO MSG_DOS_mess4 : DB " Dir. is full" : ENDM
  MACRO MSG_DOS_mess5 : DB "   No Disk" : ENDM
  MACRO MSG_DOS_mess6 : DB "    Error!" : ENDM
  MACRO MSG_DOS_mess7 : DB "Break pressed" : ENDM
  MACRO MSG_DOS_hmess : DB " Some garbage" : ENDM
  MACRO MSG_FILE_big  : DB " File big!" : ENDM

 ;Filer messages
  MACRO MSG_Filer_FMan : DB "  File Manager" : ENDM
